#include <bits/stdc++.h>
using namespace std;
int n;
long long niz[200007],ukupno;
vector <int> v[200007];
bool uzastopni;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    uzastopni=true;
    ukupno=0;
    for(int i=1;i<=n;i++){
       cin>>niz[i];
       ukupno+=niz[i];
    }
    for(int i=1;i<=n-1;i++){
        int a,b;
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
        if(abs(a-b)!=1)uzastopni=false;
    }
    if(v[1].size()==n-1){
       ukupno-=niz[1];
       if(niz[1]>=ukupno){
          cout<<ukupno<<endl;
          cout<<n-1<<endl;
          for(int i=2;i<=n;i++)cout<<i<<endl;
          cout<<0<<endl;
       }
       else{
          cout<<niz[1]<<endl;
          cout<<1<<endl;
          cout<<0<<endl;
       }
    }



return 0;
}